<?php

/* ***************************************************************************

  This is search_books.php, the PHP file that lets people search for sells
  in which a particular book (or group of books) is sold

  It can be user that people that are logged in or not. It is normally the
  page that's displayed before a user can start bid for a book, and is
  therefore optimized for that purpous. When the page is called, the user
  is presented a form where he / she can enter the book ISBN number OR
  some possible strings contained in the author name or in the title,
  and / or specify the possible subject areas of the book. If an ISBN
  number is entered, the rest is ignored.

  The script will then search in the active sells a book that corresponds
  to the user's needs... Books that are found will be sorted by price,
  and the user cna directly bid for any result.

  When called directly, this file will redirect back to the index page

**************************************************************************** */

// PHP should only report big problems
error_reporting(E_ERROR);

// Page has been called, but not by our script !!
if(bath!="university")
{
  header("Location: index.php");
  die();
}

//-- SQL
$query = <<<ENDOFSTRING
DESCRIBE $booksT `Subject`
ENDOFSTRING;
//-- ENDSQL

$columns = $db->query($query);
if(!DB::isError($columns) && ($columns->numRows())>0)
{
  $showForm = 1;

  // Get list of subjects
  $columns = $columns->fetchRow(DB_FETCHMODE_ORDERED);
  $columns = explode("'",$columns[1]);
  $col_list = array();
  for($i=1;$i<sizeof($columns);$i++)
  {
    $col_list[]=$columns[$i];
    $i++;
  }
  sort($col_list);

  // Read basic search criteria
  $isbn = read_p("form_isbn",0);
  $author = read_p("form_author",32);
  $title = read_p("form_title",32);

  // Read wanted subjects
  $subjects=array();
  for($i=0;$i<sizeof($col_list);$i++)
  {
    if(read_p("form_".$col_list[$i],2)=="on")
    {
      $subjects[] = "$booksT.`Subject` = '$col_list[$i]'";
    }
  }
  $subjects = implode(" OR ",$subjects);
  $didSearch=0;

  if($isbn || $author || $title || $subjects)
  {
    // Search, and be careful about inactive sells
    $query =  ($isbn>0?"$booksT.`ISBN` = $isbn AND ":
          ($author?"$booksT.`Authors` LIKE \"%$author%\" AND ":"").
          ($title?"$booksT.`Title` LIKE \"%$title%\" AND ":"").
          (strlen($subjects)>0?"($subjects) AND ":"")).
          " $sellsT.`Status` = 'on sale' AND $sellsT.`Date_ending` > $t";

    // Don't include the current user's sells
    if($user_id)
    {
      $query.=" AND $sellsT.`BUCS_ID` <> \"$user_id\"";
    }

//-- SQL
$query = <<<ENDOFSTRING
SELECT * FROM
$booksT JOIN $sellsT ON $booksT.`ISBN` = $sellsT.`ISBN`
WHERE $query;
ENDOFSTRING;
//-- ENDSQL

    $result = $db->query($query);
    $didSearch=1;
  }
  if(!$didSearch || !DB::isError($result))
  {
    if($didSearch && ($items=$result->numRows())>0)
    {
      echo "
      <table cellpadding='1' cellspacing='0'> 
        <tr> 
        <td align='center' valign='middle' class='Form_Cadre_title'> $items book".($items>1?"s":"")." ha".($items>1?"ve":"s")." been found... Here's the listing:</td>
        <tr>
        <td class='Form_Cadre_main' width=680 align='center'><br>
        <div style='width:650; height:250; overflow:auto'>
        <table width=630 cellpadding='1' cellspacing='0'>
          <tr>
          <td width=100 align=center class='Form_Cadre_title2'><b>ISBN</b></td>
          <td width=100 align=center class='Form_Cadre_title2'><b>Author</b></td>
          <td width=150 align=center class='Form_Cadre_title2'><b>Title</b></td>
          <td width=75 align=center class='Form_Cadre_title2'><b>Subject</b></td>
          <td width=50 align=center class='Form_Cadre_title2'><b>Price</b></td>
          <td width=80 align=center class='Form_Cadre_title2'><b>Time left</b></td>
          <td width=70 align=center class='Form_Cadre_title2'>Action</td>
          </tr>";
        $sells = array();
      $prices = array();
      
      for($i=0;$i<$items;$i++)
      {
        $current = $result->fetchRow(DB_FETCHMODE_ASSOC);
        
        $sells[$i] = array();
        $query = $current["Sell_id"];
        $sells[$i]["Sell_id"] = $query;
        $sells[$i]["ISBN"] = $current["ISBN"];
        $sells[$i]["Authors"] = $current["Authors"];
        $sells[$i]["Title"] = $current["Title"];
        $sells[$i]["Subject"] = $current["Subject"];
        $end = $current["Date_ending"] - $t;

        if($end/86400>1)
          $end=intval($end/86400)." days";
        elseif($end/3600>1)
          $end=intval($end/3600)." hours";
        elseif($end/60>5)
          $end=intval($end/60)." minutes";
        else
          $end=intval(intval($end))." seconds";

        $sells[$i]["Time_left"]=$end;

//-- SQL
$query = <<<ENDOFSTRING
SELECT `Bid_price` FROM $bidsT WHERE `Sell_id` = $query ORDER BY `Bid_price` DESC LIMIT 1
ENDOFSTRING;
//-- ENDSQL

        $query = $db->query($query);
        if(!DB::isError($query) && ($query->numRows())>0)
        {
          $query=$query->fetchRow(DB_FETCHMODE_ORDERED);
          $prices[$i]=$query[0]/10;
        }
        else
        {
          $prices[$i]=$current["Initial_price"]/10;
        }
      }
      
      array_multisort($prices,$sells,SORT_DESC);
      for($i=0;$i<$items;$i++)
      {
        if( fmod($i,2) == 1 )
          $class = "Form_Cadre_main2";
        else
          $class = "Form_Cadre_main";
        
        echo "
        <tr>
          <td align=center class='$class'>".isbn($sells[$i]["ISBN"])."</td>
          <td align=center class='$class'>".$sells[$i]["Authors"]."</td>
          <td align=center class='$class'>".$sells[$i]["Title"]."</td>
          <td align=center class='$class'>".$sells[$i]["Subject"]."</td>
          <td align=center class='$class'>".$prices[$i]." </td>
          <td align=center class='$class'>".$sells[$i]['Time_left']."</td>
          <td align=center class='$class'><a href=index.php?do=bid&sell_id=".$sells[$i]["Sell_id"]."$sess_id>Bid</a></td>
        </tr>";
      }
      
      echo "
      </table>
      </div><br>
      </td></tr></table>
      <br>";
      $showForm=0;
    }
    elseif($didSearch)
    {
      echo "We unfortunately have no one selling a book that satisfies those criterias... Maybe you should try again with other words<br><br>";
    }
  }
  else
  {
    echo "Not successful: " . $result->getMessage() . "<br><br>";
  }
  if($showForm)
  {
?>
    <script>
    function checkForm()
    {
      isbn=document.form.elements[0].value
      if(isbn.length>0)
      {
        cnt=0
        for(i=0;i<isbn.length;i++)
        {
          cur=parseInt(isbn.substring(i,i+1))
          if(cur>=0 && cur<=9)
          {
            cnt*=10
            cnt+=cur
          }
        }
        if(cnt<1 || cnt>9999999999)
        {
          alert('That is not an ISBN number!')
          return false
        }
        document.form.elements[0].value = cnt
        return true
      }
    }
    </script>
<?php
    echo "
    <table cellpadding='1' cellspacing='0'> 
        <tr> 
        <td align='center' valign='middle' class='Form_Cadre_title'> Please enter the details of the book you're looking for </td>
      <tr>
        <td class='Form_Cadre_main' align='center'>
        <br>
        <form name=form action=index.php?do=search_books$sess_id method=post onsubmit='return checkForm()'>
        <table width=500>
          <tr>
            <td align=right valign=middle width=250>ISBN: &nbsp;</td>
          <td align=left valign=middle width=250>
            <input class=inputT type=text name=form_isbn size=20 maxlength=32 value='".($isbn>0?isbn($isbn):"")."'>
          </td>
          </tr>
        <tr>
          <td align=right valign=middle></td>
          <td align=left valign=middle>-- OR --</td>
        </tr>
        <tr>
          <td align=right valign=middle>Author contains: &nbsp;</td>
          <td align=left valign=top>
            <input class=inputT type=text name=form_author size=20 maxlength=32 value=\"$author\"> and
          </td>
        </tr>
        <tr>
          <td align=right valign=middle>Title contains: &nbsp;</td>
          <td align=left valign=top>
            <input class=inputT type=text name=form_title size=20 maxlength=32 value=\"$title\"> and
          </td>
        </tr>
        <tr>
          <td align=center valign=top colspan='2'><br>Possible subject areas: &nbsp;<br><br>
            <table width=240 cellpadding=0 cellspacing=0 class=box>";
      
      for($i=0;$i<sizeof($col_list);$i+=2)
      {
      echo "
        <tr>
          <td>
          <input type=checkbox ".(strpos($subjects,$col_list[$i])===false?"":"checked ")."name='form $col_list[$i]'> $col_list[$i]</td>";
      echo "
        <td>".(($i!=sizeof($col_list)-1)?"
          <input type=checkbox ".(strpos($subjects,$col_list[$i+1])===false?"":"checked ")."name='form ".$col_list[$i+1]."'> ".$col_list[$i+1]:"")."
        </td>
        </tr>";
      }
    echo "
      </table>
      </td>
    </tr>
    </table>
    <br>
    <input name='submit' type='image' value=Submit src='images/submit.jpg'>
    <br>
    </form>
    </tr></td></table><br>
    Note that entering an ISBN number will make the rest get ignored.<br><br>When doing text based search, you can use the character % to match multiple letters and _ to match one letter:<br><b>en%</b> will for example find enabled or encyclopedia, and <b>a_on</b> will find aron or avon...";
  }
  else
  {
    echo "<a href=index.php?do=search_books$sess_id>Click here</a> to do a new search.";
  }
}
else
{
  echo "Database error: Unable to get subjects list";
}

?>
<br><br>